/*========================================================================
Date   :	01.05.2002
File   :	the_seller.pl	
By     :	Panagiotis, Zoitos (all rights reserved)
Subject:	The seller program
		Simple rule: bid a random number between Low and High, where
		Low = Last bid price
		High = Utility - minimum profit
========================================================================*/

% 4 starting the negotiotion
seller( Cost, DTS, [], AskingPrice):-
       AskingPrice is ( (Cost+1) * 5 ), %(Protected from Cost =0)
       seller_writeln(['+ Seller made the first Offer,## ', AskingPrice, ' ## ,Cost( ',Cost, ') & ', DTS ,' more Days to go ...']).



% Acceptance Rule
seller( Cost, _, [-BidPrice, +AskingPrice |_], BidPrice) :-
        BidPrice >= AskingPrice, 
	seller_writeln(['+Seller: Accept Buyers bid price (', BidPrice, ') above AskedPrice (', AskingPrice, '),Thanks !!!']) ;
        BidPrice >= Cost * 2,
        seller_writeln(['+Seller: Accept Buyers bid price (', BidPrice, ') Twice above Cost (', Cost, '), Thanks4Shopping !!!']).



% playing the negotiation
seller( Cost, DTS, [-BidPrice | _], AskingPrice):-
     (	DTS > 365  ,
        ( year_offer(DTS, MultiPlier), MultiPlier < 1000 ) ;
	DTS > 180, DTS < 366,
        ( six_month_offer(DTS, MultiPlier), MultiPlier < 1000) ;
	DTS > 30, DTS < 181,
	( month_offer(DTS, MultiPlier), MultiPlier < 1000) ;
        DTS > 3, DTS < 31,
        ( last_offer(DTS, MultiPlier), MultiPlier < 1000) ; 
        DTS < 4, DTS >0,
        ( min_offer(DTS, MultiPlier), MultiPlier < 1000) ),
       
        AskingPrice is truncate( Cost * MultiPlier )  ,
	seller_writeln(['+++++ Seller...(Buyer offered ',BidPrice, '>>> Seller Offer NOW is : ## ',
        AskingPrice, ' ## , With Cost( ',Cost, ' ) &  ',
        DTS, ' more Days to go ...']).



year_offer(Days4Selling, D):-
      D is ( 1 + ( (Days4Selling * 8)/100) ),! .

six_month_offer(Days4Selling, E):-
      E is ( 1 + ( (Days4Selling * 6)/100) ),! .

month_offer(Days4Selling, F):-
      F is ( 1 + ( (Days4Selling * 5)/100) ),! .

last_offer(Days4Selling, G):-
      G is ( 1 + ( (Days4Selling * 4)/100) ),! .

min_offer(Days4Selling, H):-
      H is ( 1 + (Days4Selling / 100) ),! .
      
 
 % By Edward Tsang ( Write the values of the prices)	 
/*----------------------------------------------------------------------*/

seller_writeln(_) :- mediator_parameter(no_explanation), !.
	/* no output if mediator suppresses reasoning */
seller_writeln([]) :- nl, !.
seller_writeln([H|T]) :- write(H), seller_writeln(T), !.

/*====================================================================*/



