/* cc283 - Intelligent Problem Solving - Assignment 2
   Robert Stacey - rpstac
   
   This program implements a seller in the negotiation game the strategy used
   is to determine which profit region the offer is in and then try to maximise 
   the profit gained.
*/

% Below are the parameter that the seller uses they are the profit margins that
% it uses to calculate when to accept offer and what bids to make.

acceptable(0.15).
prefered(0.25).
liked(0.5).
lastBid(0.1).

seller(Cost, _, [], Offer):-
	Offer is (Cost*5).

seller(_, _, [-Bid, +LastOffer, -LastBid|_], LastOffer):-
	Bid < LastBid.

seller(Cost, 1, [-Bid|_], Bid):-
	Bid > Cost.

seller(Cost, 1, [_, +LastOffer|_], Offer):-
	lastBid(Margin),
	Offer is truncate(Cost + (Margin*Cost)),
	Offer < LastOffer.

seller(_, 1, [_, +LastOffer|_], LastOffer).

seller(Cost, 2, [-Bid|_], Bid):-
	prefered(Margin),
	Profit is Cost + (Margin*Cost),
	Bid > Profit.

seller(Cost, 2, [_, +LastOffer|_], Offer):-
	prefered(Margin),
	Offer is truncate(Cost + (Margin*Cost)),
	Offer < LastOffer.

seller(Cost, 2, [_, +LastOffer|_], Offer):-
	acceptable(Margin),
	Offer is truncate(Cost + (Margin*Cost)),
	Offer < LastOffer.

seller(_, 2, [_, -LastOffer|_], LastOffer).

seller(Cost, _, [-Bid, _, -LastBid|_], Bid):-
	liked(Margin),
	Profit is Cost + (Cost*Margin),
	Bid > Profit,
	LastBid > Profit.

seller(Cost, _, [-Bid|_], Offer):-
	liked(Margin),
	Profit is truncate(Cost + (Cost*Margin)),
	Bid > Profit,
	Bid is truncate(Bid + Cost*0.1),
	max(Bid, Profit, Offer).

seller(Cost, _, [-Bid, _, -LastBid, _, -BeforeLastBid|_], Bid):-
	prefered(Margin),
	Profit is Cost + (Cost*Margin),
	Bid > Profit,
	LastBid > Profit,
	BeforeLastBid > Profit.

seller(Cost, _, [-Bid|_], Offer):-
	prefered(Margin),
	Profit is truncate(Cost + (Cost*Margin)),
	Bid > Profit,
	Bid is truncate(Bid + (Cost*0.1)),
	max(Bid, Profit, Offer).

seller(Cost, _, [-Bid, _, -LastBid, _, -BeforeLastBid, _, -OldBid|_], Bid):-
	acceptable(Margin),
	Profit is Cost + (Cost*Margin),
	Bid > Profit,
	LastBid > Profit,
	BeforeLastBid > Profit,
	OldBid > Profit.

seller(Cost, _, [-Bid, _, -LastBid|_], Offer):-
	acceptable(Margin),
	Profit is truncate(Cost + Cost*Margin),
	Bid > Profit,
	LastBid > Profit,
	Bid is truncate(Bid + Cost*0.1),
	prefered(Margin2),
	Profit is truncate(Cost + Cost*Margin2),
 	max(Bid, Profit, Offer).

seller(Cost, _, [-Bid|_], Offer):-
	acceptable(Margin),
	Profit is truncate(Cost + Cost*Margin),
	Bid > Profit,
        Bid is truncate(Bid + Cost*0.1),
	liked(Margin2),
	Profit is truncate(Cost + Cost*Margin2),
	max(Bid, Profit, Offer).

seller(Cost, _, [_, +LastOffer|_], Offer):-
	Offer is truncate(LastOffer*0.925),
        Offer > Cost.

seller( _, _, [_, +LastOffer|_], LastOffer).


max( X, Y, X):-
	X > Y.

max( X, Y, Y):-
	Y >= X.




